module("luci.controller.appfilter",package.seeall)
local o=require"luci.util"
function index()
if not nixio.fs.access("/etc/config/appfilter")then
return
end
local e
entry({"admin","services","appfilter"},
alias("admin","services","appfilter","user_list"),
_("App Filter"),20).dependent=true
entry({"admin","services","appfilter","user_list"},
arcombine(cbi("appfilter/user_list",{hideapplybtn=true,hidesavebtn=true,hideresetbtn=true}),
cbi("appfilter/dev_status",{hideapplybtn=true,hidesavebtn=true,hideresetbtn=true})),
_("User List"),21).leaf=true
entry({"admin","services","appfilter","base_setting"},
cbi("appfilter/base_setting"),_("Basic Settings"),22).leaf=true
entry({"admin","services","appfilter","user_setting"},
cbi("appfilter/user_setting"),_("Effective User"),23).leaf=true
entry({"admin","services","appfilter","time_setting"},
cbi("appfilter/time_setting"),_("Effective Time"),24).leaf=true
entry({"admin","services","appfilter","feature"},
cbi("appfilter/feature",{hideapplybtn=true,hidesavebtn=true,hideresetbtn=true}),_("App Feature"),25).leaf=true
e=entry({"admin","network","user_status"},call("user_status"),nil)
e.leaf=true
e=entry({"admin","network","dev_app_status"},call("dev_app_status"),nil)
e.leaf=true
e=entry({"admin","network","dev_visit_list"},call("get_dev_visit_list"),nil)
e.leaf=true
e=entry({"admin","network","feature_upgrade"},call("handle_feature_upgrade"),nil)
e.leaf=true
e=entry({"admin","network","dev_visit_time"},call("get_dev_visit_time"),nil)
e.leaf=true
e=entry({"admin","network","app_class_visit_time"},call("get_app_class_visit_time"),nil)
e.leaf=true
end
function get_hostname_by_mac(a)
leasefile="/tmp/dhcp.leases"
local e=io.open(leasefile,"r")
if not e then return end
while true do
local t=e:read("*l")
if not t then
break
end
local i,o,i,t,i=t:match("^(%d+) (%S+) (%S+) (%S+) (%S+)")
if a==o then
e:close()
return t
end
end
e:close()
return""
end
function handle_feature_upgrade()
local e=require"nixio.fs"
local t=require"luci.http"
local o="/tmp/feature.cfg"
local e
t.setfilehandler(
function(i,t,a)
e=io.open(o,"w")
if e and t then
e:write(t)
end
if e and a then
e:close()
end
end
)
end
function get_app_name_by_id(e)
local e=io.popen("find /tmp/appfilter/ -type f -name *.class |xargs cat |grep "..e.."|awk '{print $2}'")
if e then
local t=e:read("*l")
e:close()
return t
end
return""
end
function cmp_func(t,e)
return t.latest_time>e.latest_time
end
function user_status()
local t=require"luci.jsonc"
luci.http.prepare_content("application/json")
local e=io.open("/proc/net/af_client","r")
status_buf=e:read('*a')
e:close()
user_array=t.parse(status_buf)
local e=o.ubus("appfilter","visit_list",{});
local t=e.dev_list
local o={}
for a,e in pairs(t)do
visit_array=t[a].visit_info
for e,i in pairs(visit_array)do
print(t[a].mac,t[a].ip,visit_array[e].appid,visit_array[e].latest_time)
total_time=visit_array[e].latest_time-visit_array[e].first_time;
o[#o+1]={
mac=t[a].mac,
ip=t[a].ip,
hostname=get_hostname_by_mac(t[a].mac),
appid=visit_array[e].appid,
appname=get_app_name_by_id(visit_array[e].appid),
total_num=0,
drop_num=0,
latest_action=visit_array[e].latest_action,
latest_time=os.date("%Y/%m/%d %H:%M:%S",visit_array[e].latest_time),
first_time=os.date("%Y/%m/%d %H:%M:%S",visit_array[e].first_time),
total_time=total_time
}
end
end
table.sort(o,cmp_func)
luci.http.write_json(o);
end
function dev_app_status()
local e=require"luci.jsonc"
luci.http.prepare_content("application/json")
local e=o.ubus("appfilter","dev_list",{});
luci.http.write_json(e);
end
function get_dev_visit_time(a)
local t=require"luci.jsonc"
luci.http.prepare_content("application/json")
local e=io.open("/proc/net/af_client","r")
status_buf=e:read('*a')
e:close()
user_array=t.parse(status_buf)
local e={}
e.mac=a;
local e=o.ubus("appfilter","dev_visit_time",e);
local e=e.app_list
luci.http.write_json(e);
end
function get_app_class_visit_time(t)
local e=require"luci.jsonc"
luci.http.prepare_content("application/json")
local e={}
e.mac=t;
local e=o.ubus("appfilter","app_class_visit_time",e);
local e=e.class_list
luci.http.write_json(e);
end
function get_dev_visit_list(t)
local e=require"luci.jsonc"
luci.http.prepare_content("application/json")
local e={}
e.mac=t;
local e=o.ubus("appfilter","visit_list",e);
local t=e.dev_list
local o={}
for a,e in pairs(t)do
visit_array=t[a].visit_info
for e,i in pairs(visit_array)do
print(t[a].mac,t[a].ip,visit_array[e].appid,visit_array[e].latest_time)
total_time=visit_array[e].latest_time-visit_array[e].first_time;
o[#o+1]={
mac=t[a].mac,
ip=t[a].ip,
hostname=get_hostname_by_mac(t[a].mac),
appid=visit_array[e].appid,
appname=get_app_name_by_id(visit_array[e].appid),
total_num=0,
drop_num=0,
latest_action=visit_array[e].latest_action,
latest_time=os.date("%Y/%m/%d %H:%M:%S",visit_array[e].latest_time),
first_time=os.date("%Y/%m/%d %H:%M:%S",visit_array[e].first_time),
total_time=total_time
}
end
end
table.sort(o,cmp_func)
luci.http.write_json(o);
end
